<template>
  <div class="_container">
    <rui-field input-id="pathFormName" :label="$t('activerecord.attributes.path.name')" :placeholder="$t('js.path.default_name')">
      <input id="pathFormName" v-model="inputs.name" type="text">
    </rui-field>

    <rui-field v-if="pathId" input-id="pathFormLayer" :label="$t('activerecord.attributes.path.layer')">
      <select id="pathFormLayer" v-model="inputs.layerId" required>
        <option v-for="layer in layers" :key="layer.id" :value="layer.id">{{ layer.name }}</option>
      </select>
    </rui-field>

    <rui-field input-id="" :label="$t('js.path.inputs.preset')">
      <gpa-path-color-presets :selected-values="inputs" @choose="applyPreset" />
    </rui-field>

    <rui-field input-id="pathFormStrokeWidth" :label="$t('activerecord.attributes.path.stroke_width')">
      <select id="pathFormStrokeWidth" v-model="inputs.strokeWidth">
        <option v-for="width in [1,2,3,4,5,8,10]" :key="width" :value="width">{{ width }}</option>
      </select>
    </rui-field>

    <rui-field :label="$t('js.path.inputs.line_style')">
      <gpa-path-stroke-style-presets :width="inputs.strokeWidth"
                                     :selected="inputs.strokeStylePreset"
                                     @choose="applyStroke" />
    </rui-field>

    <rui-field :label="$t('activerecord.attributes.path.stroke_color')">
      <rui-rgba-picker v-model="inputs.strokeColor" />
    </rui-field>
    <rui-field :label="$t('activerecord.attributes.path.background_color')">
      <rui-rgba-picker v-model="inputs.backgroundColor" />
    </rui-field>

    <h3>{{ $t('js.path.inputs.preview') }}</h3>
    <div class="-text--center -mtd -checked-background">
      <gpa-path-preview :inputs="inputs" />
    </div>
  </div>
</template>

<script>
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiRgbaPicker from '@experiments-labs/rise_ui/src/components/Inputs/RgbaPicker/RgbaPicker.vue'

import GpaPathColorPresets from './_ColorPresets.vue'
import GpaPathStrokeStylePresets from './_StrokeStylePresets.vue'
import strokeStyles from '../../../../strokeStylePresets'
import GpaPathPreview from './_Preview.vue'

export default {
  name: 'GpaPathInputs',
  emits: [
    'change',
  ],
  components: { RuiRgbaPicker, RuiField, GpaPathPreview, GpaPathStrokeStylePresets, GpaPathColorPresets },
  props: {
    name: { required: false, type: String, default: null },
    strokeColor: { required: true, type: String },
    backgroundColor: { required: true, type: String },
    strokeWidth: { required: true, type: Number },
    strokeStylePreset: { required: false, type: String, default: 'default' },
    pathId: { required: false, type: Number, default: null },
    layerId: { required: false, type: Number, default: null },
    noPreview: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      strokeStyles,
      inputs: {
        name: this.$props.name,
        strokeColor: this.$props.strokeColor,
        backgroundColor: this.$props.backgroundColor,
        strokeWidth: this.$props.strokeWidth,
        strokeStylePreset: this.$props.strokeStylePreset,
        layerId: this.$props.layerId,
      },
    }
  },
  computed: {
    layers () { return this.$store.getters.layers },
  },
  methods: {
    applyPreset (preset) {
      this.inputs.strokeColor = preset.stroke
      this.inputs.backgroundColor = preset.fill
      this.inputs.strokeWidth = preset.width
      this.inputs.strokeStylePreset = preset.strokeStyle
    },
    applyStroke (key) {
      this.inputs.strokeStylePreset = key
    },
  },
  watch: {
    name (newValue, oldValue) { if (newValue !== oldValue) this.inputs.name = newValue },
    strokeColor (newValue, oldValue) { if (newValue !== oldValue) this.inputs.strokeColor = newValue },
    backgroundColor (newValue, oldValue) { if (newValue !== oldValue) this.inputs.backgroundColor = newValue },
    strokeWidth (newValue, oldValue) { if (newValue !== oldValue) this.inputs.strokeWidth = newValue },
    strokeStylePreset (newValue, oldValue) { if (newValue !== oldValue) this.inputs.strokeStylePreset = newValue },

    'inputs.name' (newValue, oldValue) {
      if (newValue !== oldValue) this.$emit('change', { key: 'name', value: newValue })
    },
    'inputs.strokeColor' (newValue, oldValue) {
      if (newValue !== oldValue) this.$emit('change', { key: 'strokeColor', value: newValue })
    },
    'inputs.strokeStylePreset' (newValue, oldValue) {
      if (newValue !== oldValue) this.$emit('change', { key: 'strokeStylePreset', value: newValue })
    },
    'inputs.backgroundColor' (newValue, oldValue) {
      if (newValue !== oldValue) this.$emit('change', { key: 'backgroundColor', value: newValue })
    },
    'inputs.strokeWidth' (newValue, oldValue) {
      if (newValue !== oldValue) this.$emit('change', { key: 'strokeWidth', value: newValue })
    },
    'inputs.layerId' (newValue, oldValue) {
      if (newValue !== oldValue) this.$emit('change', { key: 'layerId', value: newValue })
    },
  },
}
</script>
